
@class YHMainViewController;
@class YHNode;
@class YHToolbarView;
@class YHStacksKitPlugin;

@protocol YHStacksImageSaving;

enum {
	YHSWindowDirectionUp	= 0,
	YHSWindowDirectionRight	= 1,
	YHSWindowDirectionDown	= 2,
	YHSWindowDirectionLeft	= 3
};

#define kStacksNodeArchveType           @"StacksNodeArchveType"
#define kStacksNodeImageDictionaryType  @"StacksNodeImageDictionaryType"
#define kStacksNodeUidType              @"StacksNodeUidType"

@interface YHWebControlView : NSView <NSTextViewDelegate, NSTextStorageDelegate, NSLayoutManagerDelegate> {
//@interface YHWebControlView : NSView {
	
    YHStacksKitPlugin      *_plugin;
	YHMainViewController   *_nodeController;
	WebView                *_webview;
	YHToolbarView          *_toolbar;
  
	YHNode		*dragNode;
	YHNode		*hoverNode;
	YHNode		*hoverChild;
	
	NSImage		*dragImage;
	
	BOOL        editing;
	YHNode		*_editingNode;
	NSString    *editingId;
	
	BOOL		    replacing;
	YHNode		*_replacingNode;
    NSURL       *_dragImageURL;
}

- (void)updateEditingNode;
- (void)startEditing:(YHNode *)node;
- (void)stopEditing;

- (IBAction)deleteSlice:(id)sender;
//- (IBAction)cloudSlice:(id)sender;

@property (assign) IBOutlet YHStacksKitPlugin    *plugin;
@property (assign) IBOutlet YHMainViewController *nodeController;
@property (assign) IBOutlet WebView              *webview;
@property (assign) IBOutlet YHToolbarView        *toolbar;
@property (readonly)      id <YHStacksImageSaving>        sandwichController;

@property (assign) BOOL                 editing;
@property (assign) YHNode               *editingNode;
@property (retain) NSImage              *dragImage;

@property (retain)  YHNode              *replacingNode;
@property (retain)  NSURL               *dragImageURL;

@end
